/*- <matfquad/net/socket/Parameter.hpp> -*- C++ -*-
 *
 *
 *  matfquad
 *  Copyright (C) 2012  Márcio Adriano Tavares Fernandes
 *
 *  This library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
#ifndef __MATFQUAD_NET_SOCKET_PARAMETER_HPP__
#define __MATFQUAD_NET_SOCKET_PARAMETER_HPP__
#include <string>
#include <vector>

namespace matfquad
{
namespace net
{
namespace socket
{
class Parameter
{
 protected:
  std::string name;
  std::vector <std::string> nicknames;
  int number;
 protected:
  Parameter();
  Parameter(int number);
  Parameter(int number, std::string name);
  Parameter(int number, std::string name, std::vector <std::string> nicknames);
 public:
  std::string getName();
  std::vector <std::string> getNicknames();
  int getNumber();
};
}
}
}

#endif
